/*
 * Created on 08.12.2004
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package de.laliluna.tutorial.finderexample;

import java.rmi.RemoteException;
import java.util.Collection;
import java.util.Iterator;

import javax.ejb.CreateException;
import javax.naming.InitialContext;
import javax.naming.NamingException;

import de.laliluna.tutorials.finderexample.entity.interfaces.BookValue;
import de.laliluna.tutorials.finderexample.entity.interfaces.CustomerValue;
import de.laliluna.tutorials.finderexample.session.interfaces.FinderSession;
import de.laliluna.tutorials.finderexample.session.interfaces.FinderSessionHome;

/**
 * @author WinXP
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class TestFinder {

	public static void main(String[] args) {
		
		try {
			InitialContext context = new InitialContext(System.getProperties());
			//get the home interface with JNDI from the application server 
			//hole das Home Interface ber JNDI vom Applikationserver
			FinderSessionHome finderSessionHome = (FinderSessionHome)context.lookup(FinderSessionHome.JNDI_NAME);
				
			//create the session Objekt
			//erstelle das Session Objekt
			FinderSession finderSession = finderSessionHome.create();
			
			//call the init method to add some test data
			//aufrufen der Init Methode zum hinzufgen einiger Test-Daten
			finderSession.initSomeTestData();
			
			//Get all customers
			//Alle Kunden ausgeben
			System.out.println("All customers");
			System.out.println("---------------------------------------------------");
			System.out.println("id, name, age");
			System.out.println("------------------");
			
			Collection collection = finderSession.getAllCustomers();
			for (Iterator iter = collection.iterator(); iter.hasNext();) {
				CustomerValue element = (CustomerValue) iter.next();
				System.out.print(element.getId() + ", ");
				System.out.print(element.getName() + ", ");
				System.out.print(element.getAge() + "\n");
			}
			
			
			
			//Get customer by Name
			//Kunde anhand seines Namens ausgeben
			System.out.println("\nCustomer 'Peter'");
			System.out.println("---------------------------------------------------");
			
			CustomerValue customerValue = finderSession.getCustomerByName("Peter");
			System.out.print("id = " + customerValue.getId());
			System.out.print(",name = " + customerValue.getName());
			System.out.print(",age = " + customerValue.getAge() + "\n");
			
			
			
			//Get customers by book date
			//Kunden anhand des Bcherdatums ausgeben
			System.out.println("\nCustomer of books with the price 10.99");
			System.out.println("---------------------------------------------------");
			System.out.println("id, name, age");
			System.out.println("------------------");
			
			collection = finderSession.getCustomerByBookPrice(new Float(10.99));
			for (Iterator iter = collection.iterator(); iter.hasNext();) {
				CustomerValue element = (CustomerValue) iter.next();
				System.out.print(element.getId() + ", ");
				System.out.print(element.getName() + ", ");
				System.out.print(element.getAge() + "\n");
			}
			
			//Get all books
			//Alle Bcher ausgeben
			System.out.println("\nAll books");
			System.out.println("---------------------------------------------------");
			System.out.println("id, name, age");
			System.out.println("------------------");
			
			collection = finderSession.getAllBooks();
			for (Iterator iter = collection.iterator(); iter.hasNext();) {
				BookValue element = (BookValue) iter.next();
				System.out.print(element.getId() + ", ");
				System.out.print(element.getTitle() + ", ");
				System.out.print(element.getPrice() + "\n");
			}
			
			//Get books by price range
			//Bcher zwischen einer Preisspanne ausgeben
			System.out.println("\nBooks where the price is between 10 and 25");
			System.out.println("---------------------------------------------------");
			System.out.println("id, name, age");
			System.out.println("------------------");
			
			collection = finderSession.getBooksByPriceRange(new Float(10), new Float(25));
			for (Iterator iter = collection.iterator(); iter.hasNext();) {
				BookValue element = (BookValue) iter.next();
				System.out.print(element.getId() + ", ");
				System.out.print(element.getTitle() + ", ");
				System.out.print(element.getPrice() + "\n");
			}
			
			//Get books by customer name
			//Bcher anhand des Kundennamens ausgeben
			System.out.println("\nGet the books of customer 'Betti'");
			System.out.println("---------------------------------------------------");
			System.out.println("id, name, age");
			System.out.println("------------------");
			
			collection = finderSession.getBooksByCustomerName("Betti");
			for (Iterator iter = collection.iterator(); iter.hasNext();) {
				BookValue element = (BookValue) iter.next();
				System.out.print(element.getId() + ", ");
				System.out.print(element.getTitle() + ", ");
				System.out.print(element.getPrice() + "\n");
			}
			
			
			
			
		} catch (CreateException e) {
			e.printStackTrace();
		} catch (RemoteException e) {
			e.printStackTrace();
		} catch (NamingException e) {
			e.printStackTrace();
		}
		
	}
}
